package xyz.lychee.lagfixer.managers;

import com.google.gson.JsonArray;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParser;
import java.io.IOException;
import java.net.URI;
import java.nio.charset.StandardCharsets;
import java.text.MessageFormat;
import java.util.Iterator;
import java.util.concurrent.Callable;
import java.util.concurrent.TimeUnit;
import org.apache.commons.io.IOUtils;
import org.bukkit.event.EventHandler;
import org.bukkit.event.HandlerList;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.scheduler.BukkitTask;
import xyz.lychee.lagfixer.LagFixer;
import xyz.lychee.lagfixer.objects.AbstractManager;
import xyz.lychee.lagfixer.utils.MessageUtils;

public class UpdaterManager extends AbstractManager implements Listener {
   private static final JsonParser parser = new JsonParser();
   private static UpdaterManager instance;
   private boolean needupdate = false;
   private String version = "";
   private BukkitTask task;

   public UpdaterManager(LagFixer plugin) {
      super(plugin);
      instance = this;
   }

   @EventHandler
   public void onClick(PlayerJoinEvent e) {
      if (e.getPlayer().isOp() && this.needupdate) {
         SupportManager.getInstance().getFork().runLater(true, () -> {
            MessageUtils.sendMessage(true, e.getPlayer(), "Plugin needs update, latest version: &f" + this.version);
         }, 2500L);
      }

   }

   public void load() throws IOException {
      this.task = SupportManager.getInstance().getFork().runTimer(true, () -> {
         try {
            this.version = IOUtils.toString(URI.create("https://api.spigotmc.org/legacy/update.php?resource=111684"), StandardCharsets.UTF_8);
            int current = Integer.parseInt(this.getPlugin().getDescription().getVersion().split(" ")[0].replaceAll("[^0-9]", ""));
            int latest = Integer.parseInt(this.version.replaceAll("[^0-9]", ""));
            this.needupdate = current < latest;
            if (this.needupdate) {
               this.getPlugin().getLogger().info(MessageFormat.format("\n&8∘₊✧────────────────────────────────✧₊∘\n&c&lLagFixer needs an update!\n&fCurrent version: &e&n{0}&r\n&fLatest version: &e&n{1}&r\n\n&6⚠ &7Updating this plugin is crucial &6⚠\n&6⚠ &7for server optimization. &6⚠\n&8∘₊✧────────────────────────────────✧₊∘\n&fYou can disable this alert in config path:\n &emain &8-> &eupdater &8-> &efalse", this.getPlugin().getDescription().getVersion(), this.version));
            }
         } catch (IOException var3) {
         }

      }, 1L, 30L, TimeUnit.MINUTES);
      this.getPlugin().getServer().getPluginManager().registerEvents(this, this.getPlugin());
   }

   public void disable() {
      HandlerList.unregisterAll(this);
      this.task.cancel();
   }

   public boolean isEnabled() {
      return this.getPlugin().getConfig().getBoolean("main.updater");
   }

   public boolean isNeedupdate() {
      return this.needupdate;
   }

   public String getVersion() {
      return this.version;
   }

   public BukkitTask getTask() {
      return this.task;
   }

   public static UpdaterManager getInstance() {
      return instance;
   }

   public static enum VersionChecker {
      MODRINTH(() -> {
         try {
            String jsonString = IOUtils.toString(URI.create("https://api.modrinth.com/v2/project/lagfixer/version"), StandardCharsets.UTF_8);
            JsonArray versions = UpdaterManager.parser.parse(jsonString).getAsJsonArray();
            Iterator var2 = versions.iterator();

            JsonObject version;
            String versionType;
            do {
               if (!var2.hasNext()) {
                  return null;
               }

               JsonElement element = (JsonElement)var2.next();
               version = element.getAsJsonObject();
               versionType = version.get("version_type").getAsString();
            } while(!versionType.equals("release"));

            return version.get("version_number").getAsString();
         } catch (IOException var6) {
            return null;
         }
      }),
      SPIGOTMC(() -> {
         try {
            return IOUtils.toString(URI.create("https://api.spigotmc.org/legacy/update.php?resource=111684"), StandardCharsets.UTF_8);
         } catch (IOException var1) {
            return null;
         }
      });

      final Callable<String> callable;

      private VersionChecker(Callable callable) {
         this.callable = callable;
      }

      // $FF: synthetic method
      private static VersionChecker[] $values() {
         return new VersionChecker[]{MODRINTH, SPIGOTMC};
      }
   }
}
